{This component encapsulates nearly all PGP for DOS function calls.
Its freeware. You are also free to use and change the source code, but you are asked
to let me know, when you think you have found a bug or thought of an improvement
Copyright Dr. med. Wolfgang Stehle 1997  E.-Mail 044534320-0001@t-online.de
History:
10.02.97 Finput is now saved to file by the nolinefeed-procedure, which separates
lines by CRs only, making all the lines accessible for redirected input
20.02.97 instead of the hourglass I created PGP'own cursor. You can see easily
that a always got a 4 mark in arts at school german marks ranking from 1 (the best)
to 6. If you create a better cursor, send it to me.
The file for redirected input is erased automatically after use, as it might contain
your password sometimes
I integrated winexj into the pgpcomp. This was necessary as I detected
tha a global variable 'Thecallbackproc ' would lead to conflicts if you use
several instances of PGPInterface in one application. So today I destroyed
the first two of the rest of my bugs
25.02.97
From a bulletin board I got function that should allow to run this component
under Win 95 provided that you compile it with Delphi 2.0 and remove the
$define 16 Bit switch. I couldn't test it as I got no Delphi 2.0. and I havent the
foggiest idea, what they are doing there. I installed
the 16Bit version of the function as well to find out whether it runs at all. It does!
so at the moment there is some old code in the unit, that is not used 
02.03.97
Added the action Removeseckey. I think it should only be used to remove a certain
userid but not the whole key from the keyring. If you want to remove a private key
for good use the revokekey Action in order to get a revoke certificate
If no path is given PGPath is added to seckeyring and pubkeyring automatically
04.03.97 the commandline for winexec seems to get too long sometimes so instead of
writing -u pyour_userid I copy p_your_userID to myname property automatically. The command line gets shorter by this
I found that I had a fixed path to pgp.exe in my dospgp program, Path was removed so that
running should be no problem if dospgp is on the same path where PGp is found. Some more bugfixes
07.03.97 Property Test added, it defaults to false. If put to true, the pgp window
is not closed automatically and the commandline is displayed before execution
like in the older versions}
unit pgpcomp;
interface
{$Define DELPHI16}
{Note!  If you're using Delphi 2.x (32 bit), remove this line from
  this file and the Project Source code (DPR file):}



 {If you're using Delphi 1.x (16 bit), no changes are necessary.
  ----------------------------------------------------------------------}
uses
  SysUtils,WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,shellapi

  {$IFDEF DELPHI16},WinTypes
  {$ENDIF};
const
RAN_OK	=0;
NOT_FOUND=-1;
INVALID_NAME= -2;
SOME_ERROR=-3;
PGPProgrammName ='PGP.exe';
DefaultSecring='secring.pgp';
Defaultpubring='pubring.pgp';
Configname='config.txt';
type string1 =string [1];
    messagedetail=(Quiet, Normal,VerboseMessages);
    PGPLanguage= (English,Spanish,French,German,Italian,Brazilian_Portuguese,
    Esperanto,Latvian,Lithuanian,Russian,Dutch,Finnish,Hungarian,
    Norwegian,Portugese,Swedish,Danish,Icelandic,Chinese,Korean,Arabic,
    Hebrew,Greek,Turkish,Japanese);
    PGPCharset =(NOCONV,LATIN1,KOI8,ALT_CODES,ASCII, CP850 );

    PGPaction = (encryptPlaintext,signPlaintext,signKlartext,SignandEncrypt,
    ConventionalEncrypt,DecryptandChecksign,SignandEncryptMult,GenKeys,
    AddSecKeys,AddPubKeys,Extractseckeys,Extractpubkeys,Viewseckeys,Viewpubkeys,ViewpubkeysandSignatures,
    Viewallseckeys,Viewallpubkeys,ViewallpubkeysandSignatures,pubfingerprint,
    CheckPubkeysandSignatures,EditSecKey,EdPubKey,RemovePubKey,RemovesecKey,CertifPubKey,
    RemoveSig,RevokeKey,TogglePubKey,DecryptOnly,SignDetached,DetachSignature);

PGPException =class (Exception);
String500   = array[0..500] of char;
PGPInterface = class(TComponent)
  private

    { Private-Deklarationen }
         NoPif:boolean; {Switch for Win95 (doesn't run on Win 95 anyway if Filter
         Property set}
         FActive:Boolean;
         FFilter:boolean;
         FPGP_Action:PGPAction;
         PGPPath,PGPPIFCLOSEVAR,PGPPIFVAR,PGPVAR :String500;
         configlist:Tstrings;
         configChanged:boolean; {true if configlist was changed}
         FPassword, {Password for secret key}
         Textfile,    {plaintext-file for encryption, give full path if necessary}
         her_userid,   {recipients userid}


         your_userid,    {own userid}
         ciphertextfile,{ ciphertextfile, has to be in the pgp-path}
         keyfile,       { file for I/O of keys}
         seckeyring,pubkeyring,     {specify filenames for pub and sec keyring
         if not default}
         FInputfile, FOutputfile {Files for redirected IO}


    :string500;
         FInput, FOutput:TStrings; {contain PGPs IO }
          her_useridList:TStringList; {List of userid if your letter goes to severesal people}
          Ftest:boolean; {switch for testing purposes}

{and this is Phil Zimmerman's manual itself
--- Command options that can be used in combination with other
command options (sometimes even spelling interesting words!):

To produce a ciphertext file in ASCII radix-64 format, just add the
-a option when encrypting or signing a message or extracting a key:
     pgp -sea textfile her_userid
or:  pgp -kxa userid keyfile [keyring]}
PrintableAscii:string1; {contains 'a', if property
         E_Mail_Channel is set to true}


{To wipe out the plaintext file after producing the ciphertext file,
just add the -w (wipe) option when encrypting or signing a message:
     pgp -sew message.txt her_userid}
Wipeout:string1;

{To specify that a plaintext file contains ASCII text, not binary, and
should be converted to recipient's local text line conventions, add
the -t (text) option to other options:
     pgp -seat message.txt her_userid}
NotBin:string1;

{To view the decrypted plaintext output on your screen (like the
Unix-style "more" command), without writing it to a file, use
the -m (more) option while decrypting:
     pgp -m ciphertextfile}
{To specify that the recipient's decrypted plaintext will be shown
ONLY on her screen and cannot be saved to disk, add the -m option:
     pgp -steam message.txt her_userid}
Screenonly:string1;

{To recover the original plaintext filename while decrypting, add
the -p option:
     pgp -p ciphertextfile}

PlainTextFilename:string1;
function searchlist (searchparameter:string):string;
procedure exchange (Newtext,parameter:string);
procedure setFactive ( yes :Boolean);
function getpassword :string;
procedure setpassword (THePassword:string);
function getlanguage:pgplanguage;
procedure setlanguage (ALanguage:PGPLanguage);
function getmyname:string;
procedure setmyname (AName:string);
function getTmp:string;
procedure  setTMP (Tempath:string);
function gettextmode:boolean;
procedure settextmode (yes:boolean);
function getpgpcharset: pgpcharset;
procedure setpgpcharset (ACharset:pgpcharset);
procedure        setPGPPath (APath:string);
function getPGPPath :string;
function getarmor: boolean;
procedure setarmor (yes:Boolean);
function getArmorlines:integer;
procedure setArmorlines (Howmanylines:integer);
function getkpbinary:boolean;
procedure setkpbinary (yes:boolean);
function getCompress:boolean;
procedure setCompress (yes:boolean);
function  getCOMPLETES_NEEDED:integer;
procedure setCOMPLETES_NEEDED (Cplneeded:integer);
function getMARGINALS_NEEDED:integer;
procedure setMARGINALS_NEEDED (Mrgneede:integer);
function getCERT_DEPTH:integer;
procedure setCERT_DEPTH (ADepth:integer);
function getBAKRING:string;
procedure setBAKRING (ABakring:string);
function getSHOWPASS:boolean;
procedure setSHOWPASS (yes :boolean);
function getTZFIX:integer;
procedure setTZFIX (AFix:Integer);
function  getCLEARSIG :boolean;
procedure  setCLEARSIG (yes:Boolean);
function getVERBOSE:messagedetail;
procedure setVERBOSE (ADetail:Messagedetail);
function getINTERACTIVE:boolean;
procedure setINTERACTIVE (yes:boolean);
procedure settextfile (ATextfile:string);
function gettextfile :string;
function gether_userid:string;
procedure  sether_userid (AnuserId:string);

function getyour_userid:string;
procedure setyour_userid (VYouruserid:string);
function  getciphertextfile :string;
function getkeyfile : string;
procedure setkeyfile (Akeyfile:string);
procedure setPciphertextfile (ACipertextfile:string); { file mit verschlsseltem Text}
function getseckeyring:string;
procedure setseckeyring (Aseckeyring:string);
function getPpubkeyring :string;
procedure setPpubkeyring (APubKeyring:string);     {optional um bei Schlsselmanagement den Schlsselring zu
                     spezifizieren}
function GetPrintableAscii: boolean;
procedure SetPrintableAscii (Yes:boolean);
function  getWipeout:boolean;
procedure setWipeout (Yes:boolean);
procedure SetPGP_Action (Onaction:PGPaction);
function GetNotbin: boolean;
procedure setNotBin (Yes :boolean);
function getScreenonly:boolean ;
procedure setScreenonly (Yes:boolean);
function getPlainTextFilename:boolean;
procedure setPlainTextFilename (Yes:boolean);
procedure anaction;
procedure nolinefeed (var Astringlist:Tstrings;  afilename:string);function Winexejn(
pszPath,					{pathname of program to execute}
pszParams,					{command line parameters}
pszCWD:Pchar;					 { working directory}
fiCmdShow:word						{window state}
):integer;





  protected
    { Protected-Deklarationen }
  public

    { Public-Deklarationen }

  Property POutput:TStrings read Foutput; {read PGP's output from here}
  constructor create (AOwner:TComponent); override;
  destructor    destroy; override;
  Procedure whichWindows (var SubVersion, WinVersion :string);
  published
  Property PInput :TStrings read Finput write FInput; {enter redirected input here}
  property       test:boolean read Ftest write Ftest default false; {switch for testing purposes}
  Property       PFilter:boolean   read FFilter write FFilter default false; {true if IO to/fro pgp shall be redirected}
  Property       PActive :boolean read FActive write setFactive  default false;{true if actions are to be executed}
  property       Password:string read getpassword write setpassword stored false;{enter passwor here,or give it in the Pinput,
  as PGP will not accept a password from the commandline in some cases}
  Property       PPGPPath:string read getPGPPath write setPGPPath ; {Path to pgp-program if the program is not found here
  you will get an exception immediately}
  property       Ptextfile:string read gettextfile write settextfile;   {plaintext-file to encrypt or just decrypted}
  property       Pher_userid:string read gether_userid write sether_userid ;   { userid in the public keyring}
  property       Pher_useridList:TstringList  read her_useridList write her_useridList  ; {List of userid if you have a number
  of recipients}
  property       Pyour_userid:string read getyour_userid write setyour_userid ;   {own userid}
  property       Pciphertextfile:string read getciphertextfile write  setPciphertextfile;{ file with encrypted text}
  property       Pkeyfile:string read getkeyfile write setkeyfile;       { file for import/export of private or public keys}
  property       Pseckeyring:string read getseckeyring write setseckeyring ;
  property       Ppubkeyring:string read getPpubkeyring write setPpubkeyring;     {to specify a difererentkeyring}
  property       PPrintableAscii:boolean read GetPrintableAscii write SetPrintableAscii;


{To wipe out the plaintext file after producing the ciphertext file,
just add the -w (wipe) option when encrypting or signing a message:
     pgp -sew message.txt her_userid}
property       PWipeout:boolean read getWipeout write setWipeout;
property       Action :PgPAction read FPGP_Action write SetPGP_Action;
{To specify that a plaintext file contains ASCII text, not binary, and
should be converted to recipient's local text line conventions, add
the -t (text) option to other options:
     pgp -seat message.txt her_userid}
property       PNotBin:Boolean read getNotBin write setNotBin;

{To view the decrypted plaintext output on your screen (like the
Unix-style "more" command), without writing it to a file, use
the -m (more) option while decrypting:
     pgp -m ciphertextfile}
{To specify that the recipient's decrypted plaintext will be shown
ONLY on her screen and cannot be saved to disk, add the -m option:
     pgp -steam message.txt her_userid}
property       PScreenonly:boolean read getScreenonly write setScreenonly;

{To recover the original plaintext filename while decrypting, add
the -p option:
     pgp -p ciphertextfile}
property       PRecoverPlainTextFilename:boolean read getPlainTextFilename write setPlainTextFilename;

{The following is a summary of the various parameters than may be
defined in the configuration file.}


property TMP:string  read  getTmp write settmp;{ - Directory Pathname for Temporary Files
--------------------------------------------

Default setting:
TMP = ""

The configuration parameter TMP specifies what directory to use for
PGP's temporary scratch files.  The best place to put them is on a
RAM disk, if you have one.  That speeds things up quite a bit, and
increases security somewhat.  If TMP is undefined, the temporary
files go in the current directory.  If the shell environmental
variable TMP is defined, PGP instead uses that to specify where the
temporary files should go.}


property LANGUAGE:pgplanguage read getlanguage write setlanguage default English;{ - Foreign Language Selector
------------------------------------

Default setting:  LANGUAGE = "en"

PGP displays various prompts, warning messages, and advisories to the
user on the screen.  For example, messages such as "File not found.",
or "Please enter your pass phrase:".  These messages are normally in
English.  But it is possible to get PGP to display its messages to
the user in other languages, without having to modify the PGP
executable program.

A number of people in various countries have translated all of PGP's
display messages, warnings, and prompts into their native languages.
These hundreds of translated message strings have been placed in a
special text file called "language.txt", distributed with the PGP
release.  The messages are stored in this file in English, Spanish,
Dutch, German, French, Italian, Russian, Latvian, and Lithuanian.
Other languages may be added later.

The configuration parameter LANGUAGE specifies what language to
display these messages in.  LANGUAGE may be set to "en" for English,
"es" for Spanish, "de" for German, "nl" for Dutch, "fr" for French,
"it" for Italian, "ru" for Russian, "lt3" for Lithuanian, "lv" for
Latvian, "esp" for Esperanto.  For example, if this line appeared in
the configuration file:

   LANGUAGE = "fr"

PGP would select French as the language for its display messages.
The default setting is English.

When PGP needs to display a message to the user, it looks in the
"language.txt" file for the equivalent message string in the selected
foreign language and displays that translated message to the user.
If PGP can't find the language string file, or if the selected
language is not in the file, or if that one phrase is not translated
into the selected language in the file, or if that phrase is missing
entirely from the file, PGP displays the message in English.

To conserve disk space, most foreign translations are not included
in the standard PGP release package, but are available separately.

}
property MYNAME:string read getmyname write setmyname ;
{ - Default User ID for Making Signatures

----------------------------------------------

Default setting:  MYNAME = ""

The configuration parameter MYNAME specifies the default user ID to
use to select the secret key for making signatures.  If MYNAME is not
defined, the most recent secret key you installed on your secret key
ring will be used.  The user may also override this setting by
specifying a user ID on the PGP command line with the -u option.


}
property TEXTMODE:boolean read gettextmode write settextmode;{ - Assuming Plaintext is a Text File
--------------------------------------------

Default setting:  TEXTMODE = off

The configuration parameter TEXTMODE is equivalent to the -t command
line option.  If enabled, it causes PGP to assume the plaintext is a
text file, not a binary file, and converts it to "canonical text"
before encrypting it.  Canonical text has a carriage return and a
linefeed at the end of each line of text.

This mode will be automatically turned off if PGP detects that the
plaintext file contains what it thinks is non-text binary data.  If
you intend to use PGP primarily for E-mail purposes, you should turn
TEXTMODE=ON.

For VAX/VMS systems, the current version of PGP defaults TEXTMODE=ON.

For further details, see the section "Sending ASCII Text Files Across
Different Machine Environments".


}
property CHARSET:pgpcharset read getpgpcharset write setpgpcharset default noconv;
{ - Specifies Local Character Set for Text Files
------------------------------------------------------

Default setting:  CHARSET = NOCONV

Because PGP must process messages in many non-English languages with
non-ASCII character sets, you may have a need to tell PGP what local
character set your machine uses.  This determines what character
conversions are performed when converting plaintext files to and from
canonical text format.  This is only a concern if you are in a
non-English non-ASCII environment.

The configuration parameter CHARSET selects the local character set.
The choices are NOCONV (no conversion), LATIN1 (ISO 8859-1 Latin
Alphabet 1), KOI8 (used by most Russian Unix systems), ALT_CODES
(used by Russian MSDOS systems), ASCII, and CP850 (used by most
western European languages on standard MSDOS PCs).

LATIN1 is the internal representation used by PGP for canonical text,
so if you select LATIN1, no conversion is done.  Note also that PGP
treats KOI8 as LATIN1, even though it is a completely different
character set (Russian), because trying to convert KOI8 to either
LATIN1 or CP850 would be futile anyway.  This means that setting
CHARSET to NOCONV, LATIN1, or KOI8 are all equivalent to PGP.

If you use MSDOS and expect to send or receive traffic in western
European languages, set CHARSET = "CP850".  This will make PGP
convert incoming canonical text messages from LATIN1 to CP850 after
decryption.  If you use the -t (textmode) option to convert to
canonical text, PGP will convert your CP850 text to LATIN1 before
encrypting it.

For further details, see the section "Sending ASCII Text Files Across
Different Machine Environments".


}
property ARMOR:boolean read getarmor write setarmor;
{ - Enable ASCII Armor Output
---------------------------------

Default setting:  ARMOR = off

The configuration parameter ARMOR is equivalent to the -a command
line option.  If enabled, it causes PGP to emit ciphertext or keys in
ASCII Radix-64 format suitable for transporting through E-mail
channels.  Output files are named with the ".asc" extension.

If you intend to use PGP primarily for E-mail purposes, you should
turn ARMOR=ON.

For further details, see the section "Sending Ciphertext Through
E-mail Channels: Radix-64 Format" in the Essential Topics volume.


}
property ARMORLINES:integer read getArmorlines write setArmorlines;
{ - Size of ASCII Armor Multipart Files
------------------------------------------------

Default setting:  ARMORLINES = 720

When PGP creates a very large ".asc" radix-64 file for sending
ciphertext or keys through the E-mail, it breaks the file up into
separate chunks small enough to send through Internet mail
utilities.  Normally, Internet mailers prohibit files larger than
about 50000 bytes, which means that if we restrict the number of
lines to about 720, we'll be well within the limit.  The file chunks
are named with suffixes ".as1", ".as2", ".as3", ...

The configuration parameter ARMORLINES specifies the maximum number
of lines to make each chunk in a multipart ".asc" file sequence.  If
you set it to zero, PGP will not break up the file into chunks.

Fidonet E-mail files usually have an upper limit of about 32K bytes,
so 450 lines would be appropriate for Fidonet environments.

For further details, see the section "Sending Ciphertext Through
E-mail Channels: Radix-64 Format" in the Essential Topics volume.


}
property KEEPBINARY:boolean read getkpbinary write setkpbinary;
{ - Keep Binary Ciphertext Files After Decrypting
----------------------------------------------------------

Default setting:  KEEPBINARY = off

When PGP reads a ".asc" file, it recognizes that the file is in
radix-64 format and will convert it back to binary before processing
as it normally does, producing as a by-product a ".pgp" ciphertext
file in binary form.  After further processing to decrypt the ".pgp"
file, the final output file will be in normal plaintext form.

You may want to delete the binary ".pgp" intermediate file, or you
may want PGP to delete it for you automatically.  You can still rerun
PGP on the original ".asc" file.

The configuration parameter KEEPBINARY enables or disables keeping
the intermediate ".pgp" file during decryption.

For further details, see the section "Sending Ciphertext Through
E-mail Channels: Radix-64 Format" in the Essential Topics volume.


}
property COMPRESS:boolean read getCompress write setCompress;
{ - Enable Compression
-----------------------------

Default setting:  COMPRESS = on

The configuration parameter COMPRESS enables or disables data
compression before encryption.  It is used mainly for debugging PGP.
Normally, PGP attempts to compress the plaintext before it encrypts
it.  Generally, you should leave this alone and let PGP attempt to
compress the plaintext.


}
property COMPLETES_NEEDED:integer read getCOMPLETES_NEEDED write setCOMPLETES_NEEDED;
{ - Number of Completely Trusted Introducers Needed
------------------------------------------------------------------

Default setting:  COMPLETES_NEEDED = 1

The configuration parameter COMPLETES_NEEDED specifies the minimum
number of completely trusted introducers required to fully certify a
public key on your public key ring.  This gives you a way of tuning
PGP's skepticism.

For further details, see the section "How Does PGP Keep Track of
Which Keys are Valid?" in the Essential Topics volume.


}
property MARGINALS_NEEDED:integer read getMARGINALS_NEEDED write setMARGINALS_NEEDED;
{ - Number of Marginally Trusted Introducers Needed
------------------------------------------------------------------

Default setting:  MARGINALS_NEEDED = 2

The configuration parameter MARGINALS_NEEDED specifies the minimum
number of marginally trusted introducers required to fully certify a
public key on your public key ring.  This gives you a way of tuning
PGP's skepticism.

For further details, see the section "How Does PGP Keep Track of
Which Keys are Valid?" in the Essential Topics volume.


}
property CERT_DEPTH:integer read getCERT_DEPTH write setCERT_DEPTH;
{ - How Deep May Introducers Be Nested
-----------------------------------------------

Default setting:  CERT_DEPTH = 4

The configuration parameter CERT_DEPTH specifies how many levels deep
you may nest introducers to certify other introducers to certify
public keys on your public key ring.  For example, If CERT_DEPTH is
set to 1, there may only be one layer of introducers below your own
ultimately-trusted key.  If that were the case, you would be required
to directly certify the public keys of all trusted introducers on
your key ring.  If you set CERT_DEPTH to 0, you could have no
introducers at all, and you would have to directly certify each and
every key on your public key ring in order to use it.  The minimum
CERT_DEPTH is 0, the maximum is 8.

For further details, see the section "How Does PGP Keep Track of
Which Keys are Valid?" in the Essential Topics volume.




}property BAKRING:string read getBAKRING write setBAKRING; { - Filename for Backup Secret Keyring
--------------------------------------------

Default setting:  BAKRING = ""

All of the key certification that PGP does on your public key ring
ultimately depends on your own ultimately-trusted public key (or
keys).  To detect any tampering of your public key ring, PGP must
check that your own key has not been tampered with.  To do this, PGP
must compare your public key against a backup copy of your secret key
on some tamper-resistant media, such as a write-protected floppy
disk.  A secret key contains all the information that your public key
has, plus some secret components.  This means PGP can check your
public key against a backup copy of your secret key.

The configuration parameter BAKRING specifies what pathname to use
for PGP's trusted backup copy of your secret key ring.  On MSDOS, you
could set it to "a:\secring.pgp" to point it at a write-protected
backup copy of your secret key ring on your floppy drive.  This check
is performed only when you execute the PGP -kc option to check your
whole public key ring.

If BAKRING is not defined, PGP will not check your own key against
any backup copy.

For further details, see the sections "How to Protect Public Keys
from Tampering" and "How Does PGP Keep Track of Which Keys are
Valid?" in the Essential Topics volume.

!!! the next  parameters are not implemented, useless for my component!!!

PUBRING - Filename for Your Public Keyring
------------------------------------------

Default setting:  PUBRING = "$PGPPATH/pubring.pgp"

You may want to keep your public keyring in a directory separate from
your PGP configuration file in the directory specified by your
$PGPPATH environmental variable.  You may specify the full path and
filename for your public keyring by setting the PUBRING parameter.
For example, on an MSDOS system, you might want to keep your public
keyring on a floppy disk by:

   PUBRING = "a:pubring.pgp"

This feature is especially handy for specifying an alternative
keyring on the command line.


SECRING - Filename for Your Secret Keyring
------------------------------------------

Default setting:  SECRING = "$PGPPATH/secring.pgp"

You may want to keep your secret keyring in a directory separate from
your PGP configuration file in the directory specified by your
$PGPPATH environmental variable.  This comes in handy for putting
your secret keyring in a directory or device that is more protected
than your public keyring.  You may specify the full path and filename
for your secret keyring by setting the SECRING parameter.  For
example, on an MSDOS system, you might want to keep your secret
keyring on a floppy disk by:

   SECRING = "a:secring.pgp"


RANDSEED - Filename for Random Number Seed
------------------------------------------

Default setting:  RANDSEED = "$PGPPATH/randseed.bin"

You may want to keep your random number seed file (for generation of
session keys) in a directory separate from your PGP configuration file
in the directory specified by your $PGPPATH environmental variable.
This comes in handy for putting your random number seed file in a
directory or device that is more protected than your public keyring.
You may specify the full path and filename for your random seed file
by setting the RANDSEED parameter.  For example, on an MSDOS system,
you might want to keep it on a floppy disk by:

   RANDSEED = "a:randseed.bin"


PAGER - Selects Shell Command to Display Plaintext Output
---------------------------------------------------------

Default setting:  PAGER = ""

PGP lets you view the decrypted plaintext output on your screen (like
the Unix-style "more" command), without writing it to a file, if you
use the -m (more) option while decrypting.  This displays the
decrypted plaintext display on your screen one screenful at a time.

If you prefer to use a fancier page display utility, rather than
PGP's built-in one, you can specify the name of a shell command that
PGP will invoke to display your plaintext output file.  The
configuration parameter PAGER specifies the shell command to invoke
to display the file.  For example, on MSDOS systems, you might want
to use the popular shareware program "list.com" to display your
plaintext message.  Assuming you have a copy of "list.com", you may
set PAGER accordingly:

   PAGER = "list"

However, if the sender specified that this file is for your eyes
only, and may not be written to disk, PGP always uses its own
built-in display function.

For further details, see the section "Displaying Decrypted Plaintext
on Your Screen".


}
property SHOWPASS:boolean read getSHOWPASS write setSHOWPASS ; { - Echo Pass Phrase to User
-----------------------------------

Default setting:  SHOWPASS = off

Normally, PGP does not let you see your pass phrase as you type it
in.  This makes it harder for someone to look over your shoulder
while you type and learn your pass phrase.  But some typing-impaired
people have problems typing their pass phrase without seeing what
they are typing, and they may be typing in the privacy of their own
homes.  So they asked if PGP can be configured to let them see what
they type when they type in their pass phrase.

The configuration parameter SHOWPASS enables PGP to echo your typing
during pass phrase entry.


} property TZFIX:integer read getTZFIX write setTZFIX; { - Timezone Adjustment
---------------------------

Default setting:  TZFIX = 0

PGP provides timestamps for keys and signature certificates in
Greenwich Mean Time (GMT), or Coordinated Universal Time (UTC), which
means the same thing for our purposes.  When PGP asks the system for
the time of day, the system is supposed to provide it in GMT.

But sometimes, because of improperly configured MSDOS systems, the
system time is returned in US Pacific Standard Time time plus 8
hours.  Sounds weird, doesn't it?  Perhaps because of some sort of US
west-coast jingoism, MSDOS presumes local time is US Pacific time,
and pre-corrects Pacific time to GMT.  This adversely affects the
behavior of the internal MSDOS GMT time function that PGP calls.
However, if your MSDOS environmental variable TZ is already properly
defined for your timezone, this corrects the misconception MSDOS has
that the whole world lives on the US west coast.

The configuration parameter TZFIX specifies the number of hours to
add to the system time function to get GMT, for GMT timestamps on
keys and signatures.  If the MSDOS environmental variable TZ is
defined properly, you can leave TZFIX=0.  Unix systems usually
shouldn't need to worry about setting TZFIX at all.  But if you are
using some other obscure operating system that doesn't know about
GMT, you may have to use TZFIX to adjust the system time to GMT.

On MSDOS systems that do not have TZ defined in the environment, you
should make TZFIX=0 for California, -1 for Colorado, -2 for Chicago,
-3 for New York, -8 for London, -9 for Amsterdam.  In the summer,
TZFIX should be manually decremented from these values.  What a mess.

It would be much cleaner to set your MSDOS environmental variable TZ
in your AUTOEXEC.BAT file, and not use the TZFIX correction.  Then
MSDOS gives you good GMT timestamps, and will handle daylight savings
time adjustments for you.  Here are some sample lines to insert into
AUTOEXEC.BAT, depending on your time zone:

For Los Angeles:  SET TZ=PST8PDT
For Denver:       SET TZ=MST7MDT
For Arizona:      SET TZ=MST7
   (Arizona never uses daylight savings time)
For Chicago:      SET TZ=CST6CDT
For New York:     SET TZ=EST5EDT
For London:       SET TZ=GMT0BST
For Amsterdam:    SET TZ=MET-1DST
For Moscow:       SET TZ=MSK-3MSD
For Aukland:      SET TZ=NZT-13


}
property CLEARSIG:boolean read getCLEARSIG write setCLEARSIG;
{ - Enable Signed Messages to be Encapsulated as Clear Text
------------------------------------------------------------------

Default setting:  CLEARSIG = on

Normally, unencrypted PGP signed messages have a signature
certificate prepended in binary form.  Also, the signed message is
compressed, rendering the message unreadable to casual human eyes,
even though the message is not actually encrypted.  To send this
binary data through a 7-bit E-mail channel, radix-64 ASCII armor is
applied (see the ARMOR parameter).  Even if PGP didn't compress the
message, the ASCII armor would still render the message unreadable to
human eyes.  The recipient must use PGP to strip the armor off and
decompress it before reading the message.

If the original plaintext message is in text (not binary) form, there
is a way to send a signed message through an E-mail channel in such a
way that the signed message is not compressed and the ASCII armor is
applied only to the binary signature certificate, but not to the
plaintext message.  The CLEARSIG flag provides this useful feature,
making it possible to generate a signed message that can be read with
human eyes, without the aid of PGP.  Of course, you still need PGP to
actually check the signature.

The CLEARSIG flag is preset to "on" beginning with PGP version 2.5.
To enable the full CLEARSIG behavior, the ARMOR and TEXTMODE flags
must also be turned on.  Set ARMOR=ON (or use the -a option), and set
TEXTMODE=ON (or use the -t option).  If your config file has CLEARSIG
turned off, you can turn it back on again directly on the command
line, like so:

     pgp -sta +clearsig=on message.txt

This message representation is analogous to the MIC-CLEAR message type
used in Internet Privacy Enhanced Mail (PEM).  It is important to
note that since this method only applies ASCII armor to the binary
signature certificate, and not to the message text itself, there is
some risk that the unarmored message may suffer some accidental
molestation while en route.  This can happen if it passes through
some E-mail gateway that performs character set conversions, or in
some cases extra spaces may be added to or stripped from the ends of
lines.  If this occurs, the signature will fail to verify, which may
give a false indication of intentional tampering.  But since PEM
lives under a similar vulnerability, it seems worth having this
feature despite the risks.

Beginning with PGP version 2.2, trailing blanks are ignored on each
line in calculating the signature for text in CLEARSIG mode.


}
property VERBOSE:messagedetail read getVERBOSE write setVERBOSE;{ - Quiet, Normal, or Verbose Messages
--------------------------------------------

Default setting:  VERBOSE = 1

VERBOSE may be set to 0, 1, or 2, depending on how much detail you
want to see from PGP diagnostic messages.  The settings are:

0 - Display messages only if there is a problem.  Unix fans wanted
this "quiet mode" setting.

1 - Normal default setting.  Displays a reasonable amount of detail
in diagnostic or advisory messages.

2 - Displays maximum information, usually to help diagnose problems
in PGP.  Not recommended for normal use.  Besides, PGP doesn't have
any problems, right?


}
property INTERACTIVE:boolean read getINTERACTIVE write setINTERACTIVE; {
 - Ask for Confirmation for Key Adds
-----------------------------------------------

Default Setting:  INTERACTIVE = off

Enabling this mode will mean that if you add a key file containing
multiple keys to your key ring, PGP will ask for confirmation for
each key before adding it to your key ring. }



function Is_inOutput (What:string):boolean; {looks for
a string in a Stringlist, usable to analyse redirected output}

end;


procedure Register;
var tempstring,tempstring2 :string;

implementation


{$IFDEF DELPHI16}
 {$R pgp.res} {special PGP cursor}
function WinExecAndWait( Path: string500; Visibility: word ): word;
{$ELSE}
{$R pgp32.res} {special PGP cursor}
function WinExecAndWait( Path: string500; Visibility: word ): dword;
{$ENDIF}

  var
    {$IFDEF DELPHI16}
    InstanceID: THandle;
    Msg: TMsg;
  {$ELSE}
    Msg: TMsg;
    bStat: BOOL;
    pi: TProcessInformation;
    si: TStartupInfo;
    iExit: DWORD;
    bExit: boolean;
  {$ENDIF}
    hcurSave:Hcursor;
  begin

  {$IFDEF DELPHI16}
  hcursave :=SetCursor(LoadCursor(HINstance,'Cursor_2'));
  InstanceID := WinExec( Path, Visibility );
  {$ELSE}
  FillMemory( @si, sizeof( TStartupInfo ), 0 );

  with si do
    begin
    cb := sizeof( TStartupInfo );
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := Visibility;
    end;

  bStat := CreateProcess
    (
    nil,  // address of module name
    Path, // address of command line
    nil,  // address of process security attributes
    nil,  // address of thread security attributes
    false,  // new process inherits handles
    NORMAL_PRIORITY_CLASS,  // creation flags
    nil,  // address of new environment block
    nil,  // address of current directory name
    si, // address of STARTUPINFO
    pi  // address of PROCESS_INFORMATION
    );
  {$ENDIF}
  {$IFDEF DELPHI16}
  {I (W. St) inserted  $IFDEF DELPHI16 at this place. Otherwise
  InstanceID would be  evaluated in the 32bit version too without having been assigned
  a value before, so the result would be random}
  if ( InstanceID < 32 ) then { a value less than 32 indicates an Exec error }
    Result := InstanceID
  else
 {$ENDIF}
    repeat
      while ( PeekMessage( Msg, 0, 0, 0, PM_REMOVE ) ) do
        begin
        if ( Msg.Message = WM_QUIT ) then
          Halt( Msg.wParam );
             if msg.message =WM_MouseMove
             then SetCursor(LoadCursor(Hinstance,'Cursor_2'));{redisplay hourglass}
        TranslateMessage( Msg );
        DispatchMessage( Msg );
        end;
  {$IFDEF DELPHI16}
    until GetModuleUsage( InstanceID ) = 0;
    Result := 0;
  {$ELSE}
      GetExitCodeProcess( pi.hProcess, iExit );
      bExit := iExit <> STILL_ACTIVE;
    until bExit;
    CloseHandle( pi.hProcess );
    CloseHandle( pi.hThread );
    Result := iExit;
  {$ENDIF}
  SetCursor(hcurSave);
  end;

function PGPINterface.Winexejn(
pszPath,					{pathname of program to execute}
pszParams,					{command line parameters}
pszCWD:Pchar;					 { working directory}
fiCmdShow:word						{window state}
):integer;
  var Path :String500;
  begin
  if not (ftest or  (FPGP_action=GenKeys)) then  fiCmdShow:=sw_hide;{ if you
  close the window anyway you don't need to see it at all unless the user's
  keyboard input is neede by PGP for random key generation}  
       strcopy (Path,pszPath);
       strcat (Path ,' ');
       strcat  (Path,pszParams);

RESULT:=  WinExecAndWait( Path, fiCmdShow )



end;

function PGPINterface.Is_inOutput (What:string):boolean; {looks for
a string in a Stringlist, usable to analyse redirected output}

var zaehler:integer;
    tempbool:boolean;
begin
     tempbool :=false;
     for zaehler := 0 to Foutput.count-1 do
     tempbool := tempbool or (pos (What, Foutput[zaehler]) <> 0);
     result:=tempbool;
end;

procedure Register;
begin
  RegisterComponents('Internet', [PGPInterface]);
end;
constructor PGPINterface.create (AOwner:TComponent);
var Winversion,subversion: string;
begin
     inherited create (AOwner);
     whichWindows (Winversion,subversion);
     Configlist := TStringList.create;
     PActive:= False;
     her_useridList:=TStringList.create;
     PFilter:=false;
     Finput:=TStringList.create;
     FOutput:=TStringList.create;
     NoPif :=Winversion='95';{might be obsolete as we shall have to make a separate win32 version
  PPGPPath:='C:\pgp' ;
  Ptextfile:='';
  Pher_userid:='';
  Pyour_userid:='Wolfgang' ;   {own userid}
  Pciphertextfile:='';{ file with encrypted text}
  Pkeyfile:='';       { file for import/exporting keys}
  Pseckeyring:='secring.pgp';
  Ppubkeyring:='pubring.pgp';
  PPrintableAscii:=true;
  PWipeout:=false;
  PNotBin:=false;
  PScreenonly:=false;
  PRecoverPlainTextFilename:=false;
  TMP:='';
  LANGUAGE:=English;
  MYNAME:='' ;
  TEXTMODE:=false;
  CHARSET:=noconv;
  ARMOR:=False;
  ARMORLINES:=720;
  KEEPBINARY:=false;
   COMPRESS:=true;
COMPLETES_NEEDED:=1;
MARGINALS_NEEDED:=2  ;
CERT_DEPTH:=4;
BAKRING:= '';
SHOWPASS:=false;
TZFIX:=0;
CLEARSIG:=true;
VERBOSE:=Normal;
INTERACTIVE:=false;
strpcopy ( FInputfile,'InPGP.txt');
strpcopy ( FOutputfile,'Outpgp.txt');
end;
function PGPINterface.getkpbinary:boolean;
begin
     result :=searchlist ('KEEPBINARY')='on';
end;

procedure PGPINterface.setkpbinary (Yes:boolean);

begin
     if Yes then exchange ('on','KEEPBINARY')
     else exchange ('off','KEEPBINARY')
end;
function PGPINterface.getCompress:boolean;
begin
     result :=searchlist ('COMPRESS')='on';
end;

procedure PGPINterface.setCompress (Yes:boolean);
begin
     if Yes then exchange ('on','COMPRESS')
     else exchange ('off','COMPRESS')
end;
function  PGPINterface.getCOMPLETES_NEEDED:integer;
var temp: string;
    code:integer;
begin
     temp:= searchlist ('COMPLETES_NEEDED');
     val (temp,result,code);
end;

procedure PGPINterface.setCOMPLETES_NEEDED (Cplneeded:integer);
var temp: string;
begin
     str (Cplneeded,temp);
     exchange (temp,'COMPLETES_NEEDED');
end;
function PGPINterface.getMARGINALS_NEEDED:integer;
var temp: string;
    code:integer;
begin
     temp:= searchlist ('MARGINALS_NEEDED');
     val (temp,result,code);
end;

procedure PGPINterface.setMARGINALS_NEEDED (Mrgneede:integer);
var temp: string;begin
     str (Mrgneede,temp);
     exchange (temp,'MARGINALS_NEEDED');
end;
function PGPINterface.getCERT_DEPTH:integer;
var temp: string;
    code:integer;
begin
     temp:= searchlist ('CERT_DEPTH');
     val (temp,result,code);
end;

procedure PGPINterface.setCERT_DEPTH (ADepth:integer);
var temp: string;
begin
     str (ADepth,temp);
     exchange (temp,'CERT_DEPTH');
end;
function PGPINterface.getBAKRING:string;
begin
              result := searchlist ('BAKRING');
         end;

procedure PGPINterface.setBAKRING (ABakring:string);
begin
     exchange (ABakring,'BAKRING');
end;


function PGPINterface.gettextmode:boolean;
begin
     result :=searchlist ('TEXTMODE')='on';
end;
procedure PGPINterface.settextmode (Yes:boolean);
begin
     if Yes then exchange ('on','TEXTMODE')
     else exchange ('off','TEXTMODE')
end;

function PGPINterface.getSHOWPASS:boolean;
begin
     result :=searchlist ('SHOWPASS')='on';
end;

procedure PGPINterface.setSHOWPASS (Yes :boolean);
begin
     if Yes then exchange ('on','SHOWPASS')
     else exchange ('off','SHOWPASS')
end;
function PGPINterface.getTZFIX:integer;
var temp: string;
    code:integer;
begin
     temp:= searchlist ('TZFIX');
     val (temp,result,code);
end;



procedure PGPINterface.setTZFIX (AFix:Integer);

var temp: string;
begin
     str (AFix,temp);
     exchange (temp,'TZFIX');
end;
function PGPINterface.getpassword :string;
begin
     result := strpas (Fpassword);
end;
procedure PGPINterface.setpassword (THePassword:string);
begin
     strpcopy (FPassword, Thepassword);
end;
function  PGPINterface.getCLEARSIG :boolean;
begin
     result :=searchlist ('CLEARSIG')='on';
end;

procedure  PGPINterface.setCLEARSIG (Yes:Boolean);
begin
     if Yes then exchange ('on','CLEARSIG')
     else exchange ('off','CLEARSIG')
end;
function PGPINterface.getVERBOSE:messagedetail;
var code: string;
begin
     code:=searchlist ('VERBOSE');
     if code = '0'then result:=Quiet  else
     if code = '1'then result:=Normal  else
     if code = '2'then result:=VerboseMessages
end;

procedure PGPINterface.setVERBOSE (ADetail:Messagedetail);
var code: string;
begin

     if Adetail=Quiet then code :='0' else
     if Adetail=Normal then code :='1' else
     if Adetail=VerboseMessages then code :='2';
     exchange (code,'VERBOSE');
end;
function PGPINterface.getINTERACTIVE:boolean;
begin
     result :=searchlist ('INTERACTIVE')='on';
end;


procedure PGPINterface.setINTERACTIVE (Yes:boolean);
begin
     if Yes then exchange ('on','INTERACTIVE')
     else exchange ('off','INTERACTIVE')
end;

function PGPINterface.getpgpcharset: pgpcharset;
var code: string;
begin
     code:=searchlist ('CHARSET');
     if code = 'latin1'then result:=LATIN1  else
     if code = 'cp850'then result:= CP850  else
     if code = 'alt_codes'then result:=  ALT_CODES  else
     if code = 'koi8'then result:=  KOI8 else
     if code = 'ascii'then result:= ASCII else
     if code = 'noconv'then result:=NOCONV else
     result:=NOCONV
end;


procedure PGPINterface.setpgpcharset (ACharset:pgpcharset);
var code: string;
begin

     if Acharset=NOCONV then code :='noconv' else
     if Acharset=LATIN1 then code :='latin1' else
     if Acharset=KOI8 then code :='koi8' else
     if Acharset=ALT_CODES then code :='alt_codes' else
     if Acharset=ASCII then code :='ascii' else
     if Acharset=CP850 then code :='cp850';
     exchange (code,'CHARSET');
end;

procedure        PGPINterface.setPGPPath (APath:string);
 var Filename:string;
 begin if APath[length(Apath)] <>'\' then Apath:=Apath+'\'; { adds Backslash if necessary}
       if factive then begin
       Filename :=APath +'\'+ PGPProgrammName;
       if FileExists(FileName)
          then strpcopy(PGPPath,APath)
          else
       raise PGPException.create ('PGP.EXE not found in this path');
       end
       else
           strpcopy(PGPPath,APath)
       end;
function PGPINterface.getPGPPath;
begin
     result :=strPas (PGPPath);
end;
procedure PGPINterface.setFactive ( Yes :Boolean);
 var Filename:string;
 begin if Yes then
 begin
       Filename :=strpas (PGPPath)+'\'+ PGPProgrammName;
       if FileExists(FileName)
          then
          Factive:=True
          else
          begin
          Factive :=False;
          raise PGPException.create (' PGP.exe not found in this path');
          end
 end
       else
       factive :=Yes;
 end;

procedure PGPINterface.settextfile (ATextfile:string);
begin
     strpcopy(Textfile,Atextfile);
end;
function PGPINterface.gettextfile :string;
begin
result :=strpas (Textfile);
end;
function PGPINterface.gether_userid:string;
begin
result := strpas (her_userid);
delete (result,1,1);
delete  (result,length (result),1);
end;

procedure  PGPINterface.sether_userid (AnuserId:string);
begin
     AnUserID:='"'+AnuserID+'"';
     strpcopy (her_userid,ANuserID);
end;
function PGPINterface.getyour_userid:string;
begin
     result := strpas (Your_Userid);
     delete (result,1,1);
     delete  (result,length (result),1);
end;

procedure PGPINterface.setyour_userid (VYouruserid:string);
begin
     VYouruserid:='"'+VYouruserid+'"';
     strpcopy (Your_userid,VYouruserid);
end;


function  PGPINterface.getciphertextfile :string;
begin
     result := strpas (ciphertextfile);
end;
procedure PGPINterface.setPciphertextfile (ACipertextfile:string);

begin
     strpcopy (ciphertextfile, ACipertextFile);
end;
function PGPINterface.getkeyfile : string;
begin
     result :=strpas (Keyfile);
end;

procedure PGPINterface.setkeyfile (Akeyfile:string);
begin
     strpcopy (Keyfile, Akeyfile);
end;
 procedure PGPINterface.exchange (Newtext,parameter:string);{exchanges the setting of the specified parameters}
    var
   tempfound:string;
   index :integer;
begin
     index:=0;
     tempfound :='';
     while not ((index >= configlist.count-1) or (pos (Parameter,configlist[index])<>
     0)) do inc (index);
     if index <= configlist.count-1 then begin
     if (pos (Parameter,configlist[index]) <> 0)then
     begin
          Tempfound :=configlist[index];
          delete(Tempfound,(pos (Parameter,tempfound)+
          length (Parameter))+2,length (tempfound)-(pos (Parameter,tempfound
          )+length (Parameter)));
          insert (Newtext,tempfound,pos (Parameter,tempfound)+length (Parameter)+2);
          configlist[index] := tempfound;

end
else
configlist.add (Parameter + '= '+Newtext);
end
else
configlist.add (Parameter + '= '+Newtext);
configChanged:=true;
end; {exchange}
function PGPINterface.searchlist (searchparameter:string):string;
var
   tempfound:string;
   index :integer;
begin
     index:=0;
     tempfound :='';
     while not((index = configlist.count-1) or (pos (searchparameter,configlist[index])<>
     0)) do inc (index);
     if (pos (searchparameter,configlist[index]) <> 0)then begin
     tempfound :=copy (configlist [index],(pos (searchparameter,configlist[index])+
     length (searchparameter))+2,length (configlist [index])-(pos (searchparameter,configlist
     [index])+length (searchparameter)));
     searchlist :=tempfound ;
     end;
     end;

function PGPINterface.getseckeyring:string;
         begin
              result := strpas (seckeyring);
         end;
procedure PGPINterface.setseckeyring (Aseckeyring:string);
begin
     if length (Aseckeyring) = 0
        then strcopy (Seckeyring, DefaultSecring)
        else strpcopy (Seckeyring, Aseckeyring);
end;
function PGPINterface.getPpubkeyring :string;
begin
     result := strpas (Pubkeyring);
end;

procedure PGPINterface.setPpubkeyring (APubKeyring:string);     

begin
     if Length (APubkeyring) = 0
        then strcopy (Pubkeyring, DefaultPubring)
        else strpcopy (Pubkeyring, Apubkeyring);
end;



function PGPINterface.GetPrintableAscii: boolean;
begin
result :=PrintableAscii='a';
end;
procedure PGPINterface.SetPrintableAscii (Yes:boolean);
begin
     If Yes  Then PrintableAscii:='a' else PrintableAscii:=''
end;
function  PGPINterface.getWipeout:boolean;
begin
     Result := Wipeout ='w';
end;
procedure PGPINterface.setWipeout(Yes:boolean);
begin
    if Yes then Wipeout :='w' else wipeout :='';
end;
procedure PGPINterface.SetPGP_Action(Onaction:PGPaction);
begin
     FPGP_Action :=ONaction;
     Anaction;
end;

function PGPINterface.GetNotbin: boolean;
begin
     result := Notbin ='t';
end;
procedure PGPINterface.SetNotbin (Yes:boolean);
begin
     if Yes then notbin := 't' else notbin :='';
end;
function PGPINterface.getScreenonly:boolean ;
begin
     result:= Screenonly='m'
end;
procedure PGPINterface.setScreenonly (Yes:boolean);
begin
     if Yes then Screenonly:='m' else Screenonly := '';
end;
function PGPINterface.getPlainTextFilename:boolean;
begin
result := PlainTextFilename ='p'
end;
procedure PGPINterface.setPlainTextFilename (Yes:boolean);
begin
     if Yes then Plaintextfilename :='p'else Plaintextfilename :=''
end;

destructor    PGPINterface.destroy;
  begin
       configlist.free;
       her_useridList.free;
       Finput.free;
       FOutput.free;
       inherited destroy;
  end;
function PGPINterface.getTmp:string;
begin
     result :=searchlist ('TMP');
end;
procedure  PGPINterface.setTMP (Tempath:string);
begin
     exchange (Tempath,'TMP');
end;
function PGPINterface.getlanguage:pgplanguage;
var code: string;
begin
     code:=searchlist ('LANGUAGE');
     if code = 'en'then result:= English else
     if code = 'es'then result:=  Spanish else
     if code = 'fr'then result:=  French else
     if code = 'de'then result:=  German else
     if code = 'it'then result:=  Italian else
     if code = 'br'then result:=  Brazilian_portuguese else
     if code = 'esp'then result:=  Esperanto else
     if code = 'lv'then result:=  Latvian else
     if code = 'lt3'then result:=  Lithuanian else
     if code = 'ru'then result:=  Russian else
     if code = 'nl'then result:=  Dutch else
     if code = 'fi'then result:=  Finnish else
     if code = 'hu'then result:=  Hungarian else
     if code = 'no'then result:=  Norwegian else
     if code = 'pt'then result:=  Portugese else
     if code = 'sv'then result:=  Swedish else
     if code = 'da'then result:=  Danish else
     if code = 'is'then result:=  Icelandic else
     if code = 'zh'then result:=  Chinese else
     if code = 'ko'then result:=  Korean else
     if code = 'ar'then result:=  Arabic else
     if code = 'iw'then result:=  Hebrew else
     if code = 'el'then result:=  Greek else
     if code = 'tr'then result:=  Turkish else
     if code = 'Yes'then result:=  Japanese
end;
procedure PGPINterface.setlanguage (ALanguage:PGPLanguage);
var code: string;
begin

     if ALanguage= English then code :='en' else
     if ALanguage=  Spanish then code :='es' else
     if ALanguage=  French then code :='fr' else
     if ALanguage=  German then code :='de' else
     if ALanguage=  Italian then code :='it' else
     if ALanguage=  Brazilian_portuguese then code :='br' else
     if ALanguage=  Esperanto then code :='esp' else
     if ALanguage=  Latvian then code :='lv' else
     if ALanguage=  Lithuanian then code :='lt3' else
     if ALanguage=  Russian then code :='ru' else
     if ALanguage=  Dutch then code :='nl' else
     if ALanguage=  Finnish then code :='fi' else
     if ALanguage=  Hungarian then code :='hu' else
     if ALanguage=  Norwegian then code :='no' else
     if ALanguage=  Portugese then code :='pt' else
     if ALanguage=  Swedish then code :='sv' else
     if ALanguage=  Danish then code :='da' else
     if ALanguage=  Icelandic then code :='is' else
     if ALanguage=  Chinese then code :='zh' else
     if ALanguage=  Korean then code :='ko' else
     if ALanguage=  Arabic then code :='ar' else
     if ALanguage=  Hebrew then code :='iw' else
     if ALanguage=  Greek then code :='el' else
     if ALanguage=  Turkish then code :='tr' else
     if ALanguage=  Japanese then code := 'Yes';
     exchange (code,'LANGUAGE');
end;
function PGPINterface.getmyname:string;
         begin
              result := searchlist ('MYNAME');
         end;
procedure PGPINterface.setmyname (AName:string);
begin
     exchange (Aname,'MYNAME');
end;
function PGPINterface.getarmor: boolean;
begin
     result :=searchlist ('ARMOR')='on';
end;

procedure PGPINterface.setarmor (Yes:Boolean);
begin
     if Yes then exchange ('on','ARMOR')
     else exchange ('off','ARMOR')
end;
function PGPINterface.getArmorlines:integer;
var temp: string;
    code:integer;
begin
     temp:= searchlist ('ARMORLINES');
     val (temp,result,code);
end;
procedure PGPINterface.setArmorlines (Howmanylines:integer);
var temp: string;
    code:integer;

begin
     str (Howmanylines,temp);
     exchange (temp,'ARMORLINES');
end;
















 procedure PGPINterface.nolinefeed (var Astringlist:Tstrings; afilename:string);
 { writes Tstrings to file without the linefeeds}
var afile:text;
    i:integer;
begin
system.assign ( afile,afilename);
rewrite (Afile);
for i :=0 to AstringList.count-1 do
begin
     write (afile,AstringList[i]);
     write (afile,chr (13));
end;
system.close (Afile);
end;
 Procedure PGPINterface.whichWindows (var SubVersion, WinVersion :string); {finds out the windows version}
 var temp: longint;
     lower,higher,result:word;
     lbyte,hbyte:byte;
     begin temp:=getversion;
          lower := loword (temp);
          lbyte :=Lobyte  (Lower);
          Hbyte :=hibyte (Lower);
          higher:=hiword (temp);
          str (lbyte,WinVersion);
          str (hbyte,Subversion)
     end;



procedure PGPINterface.anaction;
var CmdLine,Parameters,Options,Liststring,temp:string500;
    I:integer;
    Firsttime:TDatetime;
    erasefile:file;



begin
if factive then begin{config.txt sichern}
           if configChanged then configlist.savetoFile (strpas (PGPPATH)+configname);
           strpcopy (Options,'');
           strcopy (CmdLine,' ');
           if FFilter and not (FPGP_action=GenKeys){ no Filter allowed in this case at the moment as the user's keyboard
           input is neede by PGP for random key generation} then
               begin {with redirection}

                    Nolinefeed (Finput,strpas (PGPPath)+strpas (FInputfile));
                    strpcopy (PGPPIFCLOSEVAR,'DPGPCLOS.PIF');
                    strcat    (PGPPIFCLOSEVAR,CMDLINE);
                    strpcopy (PGPPIFVAR,'DOSPGP.PIF');
                    strcat    (PGPPIFVAR,CMDLINE);
                    strpcopy (PGPVAR,'DOSPGP.exe');
                    strcat    (PGPVAR,CMDLINE);
               end
               else            {no redirection }
                   begin


                    strpcopy (PGPPIFCLOSEVAR,'PGPCLOSe.PIF');
                    strpcopy (PGPPIFVAR,'PGP.PIF');
                    strpcopy (PGPVAR,'PGP.exe');
                   end;
               strcopy (CmdLine,pgppath);
               strpcopy (parameters,'');
               if FFilter and not (FPGP_action=GenKeys){ no Filter allowed in this case}
               then
               begin
               strcat (Parameters,PGPPath);
                      strcat (Parameters,FOutputfile);
                    strcat (Parameters,' ');
                     strcat (Parameters,PGPPath);
                     strcat (Parameters,FInputfile);
               end;
               strcat (Parameters,' ');
{PGP Quick Reference cited in the comments}
if not test then PGPPifVar:=PGPpifcloseVar;
case FPGP_action of

encryptPlaintext:
{
To encrypt a plaintext file with the recipient's public key:
     pgp-e textfile her_userid}

     begin {is everthing filled in?}
     if not (FileExists(strpas (textfile))) or (strpas (her_userid) ='')
     then
     raise PGPException.create ('Textfile missing or user-id empty');
          strpcopy (Options, PrintableAscii+Wipeout+NotBin+Screenonly);
          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          
          if FFilter then
          strcat (Parameters,'-e')
          else strcat (Parameters,'-e');
          strcat(Parameters,Options);
          strcat (Parameters,' ');
          strcat (Parameters,textfile);
          strcat (Parameters,' ');
          strcat (Parameters,her_userid);
     end;
signPlaintext:
{To sign a plaintext file with your secret key:
     pgp -s textfile [-u your_userid]}

begin    if not (FileExists(strpas (textfile))) or (strpas (your_userid)='')
     then
     raise PGPException.create ('textfile missing or userid empty');
         strpcopy(Options, NotBin+PrintableAscii+Wipeout+Screenonly);
          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          strcat (CmdLine,' ');
          if FFilter then strcat (Parameters,' -z ')else strcat (Parameters,' -z ');
          strcat  (Parameters,FPassword);
          strcat (Parameters,' ');
          strcat (Parameters,'-s');
          strcat(Parameters,Options);
          strcat (Parameters,' ');
          strcat (Parameters,textfile);
          Myname:=PYour_userid;
     end;
signKlartext:
{To sign a plaintext ASCII text file with your secret key, producing a
signed plaintext message suitable for sending via E-mail:
<eigene Erklrung: hierbei wird die Kompression ausgeschaltet,
der Empfnger bentigt kein PGP, um den Text lesen zu knnen>
     pgp -sta textfile [-u your_userid]}
begin
if not (FileExists(strpas (textfile))) or (strpas (your_userid)='')
     then
     raise PGPException.create ('textfile not found or own userid empty');
           strpcopy(Options,Wipeout+Screenonly);
          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);

           if FFilter then strcat (Parameters,' -z ') else strcat (Parameters,' -z ');
          strcat  (Parameters,FPassword);
         strcat (parameters,' ');
          strcat (Parameters,'-sta');
          strcat(Parameters,Options);
         strcat (parameters,' ');
          strcat (Parameters,textfile);
          Myname:=PYour_userid;
          end;
SignandEncrypt:

{To sign a plaintext file with your secret key, and then encrypt it
with the recipient's public key:
pgp -es textfile her_userid [-u your_userid]}
begin    if not (FileExists(strpas(textfile))) or (strpas(your_userid)='')
or (strpas(her_userid)='')

     then
     raise PGPException.create ('Textfile not found or own or recipients userid empty');

          strpcopy(Options,NotBin+PrintableAscii+Wipeout+Screenonly);
          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);

          if FFilter then  strcat (Parameters,' -z ')  else strcat (Parameters,' -z ');
          strcat  (Parameters,FPassword);
          strcat (parameters,' ');
          strcat (Parameters,'-es');
          strcat(Parameters,Options);
          strcat (parameters,' ');
          strcat (Parameters,textfile);
          strcat (parameters,' ');
          strcat (Parameters,her_userid);
          Myname:=PYour_userid;
     end;
ConventionalEncrypt:

{To encrypt a plaintext file with just conventional cryptography, type:
 <Sicherung von Archiv-Files>
     pgp -c textfile}
begin
     if not (FileExists(strpas(textfile)))
     then
     raise PGPException.create ('Textfile missing ');

     strpcopy(Options,NotBin+PrintableAscii+Wipeout);
     if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);

     if FFilter then strcat (Parameters,'-c') else strcat (Parameters,'-c');
          strcat(Parameters,Options);
         strcat (Parameters,' ');
          strcat (Parameters,textfile);
end;
DecryptandChecksign:{
To decrypt an encrypted file, or to check the signature integrity of a
signed file:
     pgp ciphertextfile [-o plaintextfile] >Ciphertextfile mu im PGP-Pfad stehen}
 begin    if not (FileExists(strpas (ciphertextfile))) or (strpas (textfile)='')
     then
     raise PGPException.create ('Ciphertextfile missing or name of output-textfile not specified');

          strpcopy(Options,Screenonly+PlainTextFilename);
          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);

          if FFilter then strcat(CmdLine,'- ')else strcat(CmdLine,' ');
          strcat(Parameters,Options);
         strcat (Parameters,' ');
          strcat (Parameters,ciphertextfile);
          strcat (Parameters,' -o');
         strcat (Parameters,' ');
          strcat (Parameters,Textfile);
     end;

SignandEncryptMult:



{To <sign> and encrypt a message for any number of multiple recipients:
     pgp -e textfile userid1 userid2 userid3
     < das Zeichen -s wurde hinzugefgt, da diese Funktion fr uns wichtiger ist>}
begin        if not (FileExists(strpas(textfile))) or (strpas(your_userid)='')
or (her_useridList.count =0)

     then
     raise PGPException.create ('Textfile missing or own userid or recipients  Userid-list empty');



      strcopy (ListString,'');
    for I:= 0 to her_UseridList.count-1 do
     begin
     strcat (ListString,strpcopy(temp,her_UseridList.strings [I]));
     if I <her_UseridList.count-1
     then
     strcat (ListString,' ');
     end;

          strpcopy(Options,PrintableAscii+Wipeout+NotBin+Screenonly+PlainTextFilename);
           if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);

          if FFilter then  strcat (Parameters,' -z ') else strcat (Parameters,' -z ');
          strcat  (Parameters,FPassword);
         strcat (Parameters,' ');
          strcat (Parameters,'-es');
          strcat(Parameters,Options);
         strcat (Parameters,' ');
          strcat (Parameters,textfile);
         strcat (Parameters,' ');
          strcat (Parameters,ListString);
          Myname:=PYour_userid;
     end;






{--- Key management commands:}
GenKeys:
{To generate your own unique public/secret key pair:
     pgp -kg}
     begin      if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);

          if FFilter then  strcat    (Parameters,' -kg') else strcat(Parameters,' -kg');
end;
AddSecKeys:

{To add a public or secret key file's contents to your public or
secret key ring:
     pgp -ka keyfile [keyring]}
begin
        if not (FileExists(strpas (PGPPATH)+strpas(seckeyring)) or
      ( (strpos (seckeyring,'\') <>nil)and FileExists(strpas(seckeyring))))
 or not (FileExists(strpas (Keyfile)))

     then
     raise PGPException.create ('the keyring or the keyfile are missing');


           if nopif then strcat(CmdLine,PGPVAR ) else strcat   (CmdLine,PGPPIFCLOSEVAR);
         if FFilter then   strcat (Parameters,'-ka')else  strcat (Parameters,'-ka');
         strcat (Parameters,' ');
          strcat (Parameters,keyfile);
         strcat (Parameters,' ');
          if (strpos (seckeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,seckeyring);
     end;
AddPubKeys:

{To add a public or secret key file's contents to your public or
secret key ring:
     pgp -ka keyfile [keyring]}

     begin
        if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
      or not (FileExists(strpas (Keyfile)))

     then
     raise PGPException.create ('the specified keyring or the keyfile are missing');

           if nopif then strcat(CmdLine,PGPVAR ) else strcat   (CmdLine,PGPPIFCLOSEVAR);
          if FFilter then   strcat (Parameters,'-ka') else strcat (Parameters,'-ka');      strcat (Parameters,' ');
          strcat (Parameters,keyfile);
         strcat (Parameters,' ');
          if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
     end;



     Extractseckeys:

{To extract (copy) a key from your public or secret key ring:
     pgp -kx userid keyfile [keyring]
or:  pgp -kxa userid keyfile [keyring]}

begin
        if not (FileExists(strpas (PGPPATH)+strpas(seckeyring)) or
      ( (strpos (seckeyring,'\') <>nil)and FileExists(strpas(seckeyring))))
 or
        (strpas(your_userid)='') or (strpas (Keyfile)='')

     then
     raise PGPException.create ('Specified keyring or, keyfile missing or user_Id empty');
          strpcopy(Options,PrintableAscii);
           if nopif then strcat(CmdLine,PGPVAR ) else strcat  (CmdLine,PGPPIFCLOSEVAR);
          if FFilter then   strcat (Parameters,'-kx')else strcat (Parameters,'-kx');
          strcat(Parameters,Options);
         strcat (Parameters,' ');
          strcat (Parameters,your_userid);
         strcat (Parameters,' ');
          strcat (Parameters,keyfile);
         strcat (Parameters,' ');
          if (strpos (seckeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,seckeyring);
end;
Extractpubkeys:

{To extract (copy) a key from your public or secret key ring:
     pgp -kx userid keyfile [keyring]
or:  pgp -kxa userid keyfile [keyring]}

begin
          if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
     or
        (strpas(her_userid)='') or (strpas (Keyfile)='')

     then
     raise PGPException.create ('Specified keyring missing or keyfile or user-ID empty');


          strpcopy(Options,PrintableAscii);
           if nopif then strcat(CmdLine,PGPVAR ) else strcat  (CmdLine,PGPPIFVAR);
          if FFilter then   strcat (Parameters,'-kx') else strcat (Parameters,'-kx');
          strcat(Parameters,Options);
         strcat (Parameters,' ');
          strcat (Parameters,her_userid);
         strcat (Parameters,' ');
          strcat (Parameters,keyfile);
         strcat (Parameters,' ');
          if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
end;
Viewseckeys:
{To view the contents of your public key ring:
     pgp -kv[v] [userid] [keyring]
     <this works for secret keys as well and comes first here>}
begin   if not (FileExists(strpas (PGPPATH)+strpas(seckeyring)) or
      ( (strpos (seckeyring,'\') <>nil)and FileExists(strpas(seckeyring))))
 or
        (strpas(your_userid)='')

     then
     raise PGPException.create ('Specified Keyring not found  or userid empty');
            if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          if FFilter then strcat (Parameters,'-kv') else strcat (Parameters,'-kv');
         strcat (Parameters,' ');
          strcat (Parameters,your_userid);
         strcat (Parameters,' ');
          if (strpos (seckeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,seckeyring);
end;

Viewpubkeys:
{To view the contents of your public key ring:
     pgp -kv[v] [userid] [keyring]
     <>}
begin
     if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
      or
        (strpas(her_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');

           if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          if FFilter then strcat (Parameters,'-kv') else strcat (Parameters,'-kv');
         strcat (Parameters,' ');
          strcat (Parameters,her_userid);
         strcat (Parameters,' ');
          if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
end;
ViewpubkeysandSignatures:
{To view the contents of your public key ring:
     pgp -kv[v] [userid] [keyring]
     <including a the trusted introducers signature>}
begin
        if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
      or
        (strpas(your_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or userid empty');
           if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          if FFilter then strcat (Parameters,'-kvv') else strcat (Parameters,'-kvv');
         strcat (Parameters,' ');
          strcat (Parameters,her_userid);
         strcat (Parameters,' ');
          if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
end;
Viewallseckeys:
{To view the contents of your public key ring:
     pgp -kv[v] [userid] [keyring]
     <geht auch fr private Keys und das kommt zuerst>}
begin     if not (FileExists(strpas (PGPPATH)+strpas(seckeyring)) or
      ( (strpos (seckeyring,'\') <>nil)and FileExists(strpas(seckeyring))))

          then raise PGPException.create ('Specified keyring not found ');
           if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          if FFilter then strcat (Parameters,'-kv')else strcat (Parameters,'-kv');
         strcat (Parameters,' ');
          if (strpos (seckeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,seckeyring);
end;

Viewallpubkeys:
{To view the contents of your public key ring:
     pgp -kv[v] [userid] [keyring]
     <does not work as PGP assumes that the first optional parameter is a
     USER-ID>}
begin
if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))

then raise PGPException.create ('Specified keyring not found ');
           if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          if FFilter then strcat (Parameters,'-kv') else strcat (Parameters,'-kv');
         strcat (Parameters,' ');
         if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
end;
ViewallpubkeysandSignatures:
{To view the contents of your public key ring:
     pgp -kvv [userid] [keyring]
     <inclusive der Beglaubigungssignatur>}
begin     if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
         then  raise PGPException.create ('Specified keyring not found ');

          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          if FFilter then strcat (Parameters,'-kvv') else strcat (Parameters,'-kvv');
         strcat (Parameters,' ');
          if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
end;
pubfingerprint:


{To view the "fingerprint" of a public key, to help verify it over
the telephone with its owner:
     pgp -kvc [userid] [keyring]}
     begin
                   if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
     or
        (strpas(her_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');


               if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
               if FFilter then strcat (Parameters,'-kvc') else strcat (Parameters,'-kvc');
              strcat (Parameters,' ');
               strcat (Parameters,her_userid);
              strcat (Parameters,' ');
               if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
     end;

CheckPubkeysandSignatures:
{To view the contents and check the certifying signatures of your
public key ring:
     pgp -kc [userid] [keyring]}
begin

     if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
      or  (strpas(her_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');

               if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
               if FFilter then strcat (Parameters,'-kc') else strcat (Parameters,'-kc');;
              strcat (Parameters,' ');
               strcat (Parameters,her_userid);
              strcat (Parameters,' ');
               if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
end;

EditSecKey:
{To edit the userid or pass phrase for your secret key:
     pgp -ke userid [keyring]}
begin     if not (FileExists(strpas (PGPPATH)+strpas(seckeyring)) or
      ( (strpos (seckeyring,'\') <>nil)and FileExists(strpas(seckeyring))))
 or
        (strpas(your_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');
    if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
         ;
           strcat (Parameters,' ');
          strcat (Parameters,'-ke');
          strcat (Parameters,' ');
          strcat (Parameters,your_userid);
         strcat (Parameters,' ');
          if (strpos (seckeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,seckeyring);
end;

EdPubKey: {To edit the trust parameters for a public key:
     pgp -ke userid [keyring]}
begin               if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
      or
        (strpas(her_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');

               if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
               if FFilter then strcat  (CmdLine,'-ke')else strcat (Parameters,'-ke');
              strcat (Parameters,' ');
               strcat (Parameters,her_userid);
              strcat (Parameters,' ');
               if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
end;
RemovesecKey:

{To remove a key or just a userid from your private key ring:
     pgp -kr userid [keyring]}
 begin   if not (FileExists(strpas (PGPPATH)+strpas(seckeyring)) or
      ( (strpos (seckeyring,'\') <>nil)and FileExists(strpas(seckeyring))))
     or
        (strpas(your_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');

               if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
               if FFilter then strcat (Parameters,'-kr')else strcat (Parameters,'-kr');
              strcat (Parameters,' ');
               strcat (Parameters,your_userid);
              strcat (Parameters,' ');
               if (strpos (seckeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,seckeyring);
end;
RemovePubKey:

{To remove a key or just a userid from your public key ring:
     pgp -kr userid [keyring]}
 begin   if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
     or
        (strpas(her_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');

               if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
               if FFilter then strcat (Parameters,'-kr')else strcat (Parameters,'-kr');
              strcat (Parameters,' ');
               strcat (Parameters,her_userid);
              strcat (Parameters,' ');
               if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
end;

CertifPubKey:
{To sign and certify someone else's public key on your public key ring:
     pgp -ks her_userid [-u your_userid] [keyring]}
             begin
                  if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
     or
        (strpas(her_userid)='') or
        (strpas(your_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');

               if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
               if FFilter then strcat (Parameters,'-ks')else strcat (Parameters,'-ks');
              strcat (Parameters,' ');
               strcat (Parameters,her_userid);
              strcat (Parameters,' ');
              { strcat (Parameters,'-u');
              strcat (Parameters,' ');
               strcat (Parameters,your_userid);
              strcat (Parameters,' ');}
              myname :=Pyour_userid;
               if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
               end;

RemoveSig:


{To remove selected signatures from a userid on a keyring:
     pgp -krs userid [keyring]}
          begin
                  if not (FileExists(strpas (PGPPATH)+strpas(Pubkeyring)) or
      ( (strpos (pubkeyring,'\') <>nil)and FileExists(strpas(Pubkeyring))))
     or
        (strpas(your_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or Userid empty');


               if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
               if FFilter then strcat (Parameters,'-kr') else strcat (Parameters,'-kr');
              strcat (Parameters,' ');
               strcat (Parameters,her_userid);
              strcat (Parameters,' ');
               if (strpos (pubkeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,pubkeyring);
          end;

RevokeKey:

{To permanently revoke your own key, issuing a key compromise
certificate:
     pgp -kd your_userid} {mu hier nicht optional ein SecKeyring hin, Phil?}
begin
                  if not (FileExists(strpas (PGPPATH)+strpas(seckeyring)) or
      ( (strpos (seckeyring,'\') <>nil)and FileExists(strpas(seckeyring))))
 or
        (strpas(your_userid)='')

     then
     raise PGPException.create ('Specified keyring not found or a Userid empty');


          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          if FFilter then strcat (Parameters,'-kd')else strcat (Parameters,'-kd');
         strcat (Parameters,' ');
          strcat (Parameters,your_userid);
         strcat (Parameters,' ');
          if (strpos (seckeyring,'\') =nil) then strcat (Parameters,PGPPath);strcat (Parameters,seckeyring);

end;
TogglePubKey:

{To disable or reenable a public key on your own public key ring:
     pgp -kd userid}
              begin
                  if (strpas(her_userid)='')

     then
     raise PGPException.create ('Userid empty');


               if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
               if FFilter then strcat (Parameters,'-kd')else strcat (Parameters,'-kd');
              strcat (Parameters,' ');
               strcat (Parameters,her_userid);
          end;


{--- Esoteric commands:}
DecryptOnly:

{To decrypt a message and leave the signature on it intact:
     pgp -d ciphertextfile}
     begin
                  if not (FileExists(strpas(ciphertextfile)))
     then
     raise PGPException.create ('CiphertextFile not found');


          strpcopy(Options, Screenonly+PlainTextFilename);
          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
          if FFilter then strcat (Parameters,' -d')else strcat (Parameters,' -d');
          strcat(Parameters,Options);
         strcat (Parameters,' ');
          strcat (Parameters,ciphertextfile);
     end;
SignDetached:
{To create a signature certificate that is detached from the document:
     pgp -sb textfile [-u your_userid]}
begin
                  if not (FileExists(strpas(Textfile))) or
        (strpas(your_userid)='')

     then
     raise PGPException.create ('Specified file not found or Userid empty');


         if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
         if FFilter then  strcat (Parameters,'-sb')else  strcat (Parameters,'-sb');
         strcat (Parameters,' ');
          strcat (Parameters,textfile);
         strcat (Parameters,' ');
         Myname:=PYour_userid;
     end;

DetachSignature:
{To detach a signature certificate from a signed message:
     pgp -b ciphertextfile}
begin     if not (FileExists(strpas(ciphertextfile)))
     then
     raise PGPException.create ('CiphertextFile not found');

          if nopif then strcat(CmdLine,PGPVAR ) else strcat(CmdLine,PGPPIFVAR);
           if FFilter then strcat (Parameters,' -b') else strcat (Parameters,' -b');
          strcat (Parameters,' ');
          strcat (Parameters,ciphertextfile);
end;

end;
if configChanged then configlist.savetofile (strpas (PGPPath)+configname);



tempstring :=strpas (Cmdline);
tempstring2 :=strpas (Parameters);
if ftest then MessageDlg(tempstring+' '+tempstring2, mtInformation,
      [mbOk], 0);
if Winexejn(
CMDLINe,					{pathname of program to execute}
Parameters,					{command line parameters}
PGPPath,sw_shownormal					 { working directory}
)= ran_ok then begin
if FFilter and not (FPGP_action=GenKeys) then
   begin
   system.assign ( erasefile,strpas (PGPPath)+strpas (FInputfile));
   erase (erasefile);

 FOutput.loadFromFile (strpas (PGPPath)+strpas (FOutputfile));
end;
end;
end;
end;

end.

